unit sfwh;
{$o-}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CPDrv, ComCtrls, ExtCtrls;

const
_reset	   =$99;	//  
_empty	   =$11;        //  
_Ident	   =$22;        //   
_ReadBlock  =$33;	//  
_WriteBlock =$44;	//  
_EraseBlock =$55;	//  

//  
_OK         =00;        //   

//   .
_First=$1 ; //  
_Last  =$2;  //  
_FullErase  =$3;  //  .  SST

//    /
_Intel ='I';	//  Intel
_SST ='S';	//  SST

//   
_2M= $3FFFF+1;
_3M= $5FFFF+1;
_4M= $7FFFF+1;
_8M= $FFFFF+1;

//    
//  Intel 64K  SST 16K  64K
//      
//        16

MinBlock=$4000;
BS=32768;               //    

type
  TForm1 = class(TForm)
    Com: TCommPortDriver;
    Ident: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    READbutton: TButton;
    Erase: TButton;
    WriteBlock: TButton;
    StatusBar1: TStatusBar;
    CheckBox1: TCheckBox;
    PortSelect: TRadioGroup;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComRX(Sender: TObject; DataPtr: Pointer; DataSize: Cardinal);
    procedure IdentClick(Sender: TObject);
    procedure READbuttonClick(Sender: TObject);
    procedure EraseClick(Sender: TObject);
    procedure WriteBlockClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

TheChip =record
        ID:Word;         ///   /
        N:String[32];
        T:char;         //      
        Size:dword;        //    
        end;
TheBlock=Array [0..127] of byte;

var
  Form1: TForm1;

InputB:array of byte; //   
IndexB:cardinal;      //  
SendBuffer:array[0..8] of byte;
DataBuffer:TheBlock;

ButtonPressed:boolean=false; //    
                             //       

TimeOutCommand:dword=5000;   //     
                            //   

TimeOutData:Dword=5000;    //     
                           //    

Fin:file of TheBlock;
Fout:file of byte;
Chip:TheChip;

implementation

{$R *.dfm}

Function FindFile(name:string):longint;
// -1  ,   ;
var
  sr: TSearchRec;
  FileAttrs: Integer;
begin
result:=-1;
FileAttrs := 0;
if FindFirst(name, FileAttrs, sr)=0 then
 begin
  result:=sr.size;
  FindClose(sr);
 end;
end;

Function GetCPUSpeed: Double;
const
  DelayTime = 500;
var
  TimerHi      : DWORD;
  TimerLo      : DWORD;
  PriorityClass: Integer;
  Priority     : Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);
  Result := TimerLo / (1000.0 * DelayTime);
end;
//-----------------------------------------------------------------------
Procedure Delay(ms:cardinal);
var thetime:cardinal;
begin
TheTime:=GetTickCount+ms;
while TheTime>GetTickCount do Application.ProcessMessages;
end;
//-----------------------------
function PortHold:boolean;
begin
 case Form1.PortSelect.ItemIndex of
 0:Form1.Com.Port:=pnCom1;
 1:Form1.Com.Port:=pnCom2;
 2:Form1.Com.Port:=pnCom3;
 3:Form1.Com.Port:=pnCom4;
 4:Form1.Com.Port:=pnCom5;
 5:Form1.Com.Port:=pnCom6;
 6:Form1.Com.Port:=pnCom7;
 7:Form1.Com.Port:=pnCom8;
 end;
 if Form1.Com.Connect then
  begin
   Form1.PortSelect.Enabled:=false;
   result:=true
  end
  else result:=false;
end;
//------------------------------------------
Procedure PortUnHold;
begin
 Form1.Com.DisConnect;
 Form1.PortSelect.Enabled:=true;
end;
//----------------------------------------
function ExecCommand(c:byte):boolean;
var thetime:cardinal;
begin
result:=false;
SendBuffer[0]:=C;
IndexB:=0; //    
form1.Com.FlushBuffers(TRUE,TRUE); //    COM 

if form1.com.SendData(@SendBuffer,8)<>8 then
 begin
  MessageDlg('  !', mtError, [mbYes], 0);
  exit;
 end;

TheTime:=GetTickCount+TimeOutCommand;

While (IndexB<8)and (TheTime>GetTickCount)
 do Application.ProcessMessages;

//if IndexB>8 then
// MessageDlg('   8 !', mtError, [mbYes], 0);

if IndexB<8 then
 MessageDlg('   8 !', mtError, [mbYes], 0);

if IndexB=0 then
 MessageDlg('    !'+chr(10)+chr(13)+'  .', mtError, [mbYes], 0);

if ((InputB[0]<>_ok) or (InputB[1]<>C)) AND (IndexB=8) then
 MessageDlg('   :"'+IntToHex(InputB[0],2)+' '+InttoHex(InputB[1],2)
            +'".', mtError, [mbYes], 0);

if (InputB[0]=_ok) AND (InputB[1]=C)then result:=TRUE;

end;
//--------------------------------------------------------
function GetAnswer:boolean;
var thetime:cardinal;
begin
result:=false;

TheTime:=GetTickCount+TimeOutCommand div 2;
While (IndexB<8)and (TheTime>GetTickCount)
 do Application.ProcessMessages;

if IndexB<8 then
begin
TheTime:=GetTickCount+TimeOutCommand div 2;
While (IndexB<8)and (TheTime>GetTickCount)
 do Application.ProcessMessages;
end;

if IndexB<8 then
form1.memo1.lines.add('   8 !');

if IndexB=0 then
 form1.memo1.lines.add('    !');

if (InputB[0]<>_ok) AND (IndexB=8) then
 MessageDlg('   :"'+IntToHex(InputB[0],2)+' '+InttoHex(InputB[1],2)
            +'".', mtError, [mbYes], 0);

if (InputB[0]=_ok) AND (IndexB=8) then result:=TRUE;

IndexB:=0; //    
form1.Com.FlushBuffers(TRUE,TRUE); //    COM 
end;
//-------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Com.DisConnect;
end;
//-------------------------------------------
procedure TForm1.ComRX(Sender: TObject; DataPtr: Pointer;
  DataSize: Cardinal);
 var p:pointer;
begin
 p:=@InputB[IndexB];
 move( DataPtr^, p^, DataSize );
 Inc(indexB, DataSize);
// label1.Caption:=intToStr(ByteCounter);
end;
//------------------------------------------
Function ExecIdent:boolean;
Var S:string;
begin
Result:=false;
form1.memo1.lines.add('+++   .');
if ExecCommand(_Ident) then
 begin
 Chip.N:='';    //    
 Chip.ID:=(InputB[2] shl 8)+InputB[3];
 Case Chip.ID of
// Intel
 $89AD:begin
        Chip.N:='i80282AB 4Mbit';
        Chip.T:='I';
        Chip.Size:=_4M;
       end;
 $89AC:begin
        Chip.N:='i80282AC 8Mbit';
        Chip.T:='I';
        Chip.Size:=_8M;
       end;
// Atmel
 $1FE9:begin
        Chip.N:='AT49LH002 2Mbit';
        Chip.T:='I';
        Chip.Size:=_2M;
       end;

 $1FEE:begin
        Chip.N:='AT49LH004 4Mbit';
        Chip.T:='I';
        Chip.Size:=_4M;
       end;


 end; //     (Intel)
//SST
if Chip.N='' then
begin
 Chip.ID:=(InputB[4] shl 8)+InputB[5];
 Case Chip.ID of
 $BF57:begin
        Chip.N:='SST49LF002A 2Mbit';
        Chip.T:='S';
        Chip.Size:=_2M;
       end;
 $BF1B:begin
        Chip.N:='SST49LF003A 3Mbit';
        Chip.T:='S';
        Chip.Size:=_3M;
       end;

 $BF60:begin
        Chip.N:='SST49LF004A/B 4Mbit';
        Chip.T:='S';
        Chip.Size:=_4M;
       end;
 $BF58:begin
        Chip.N:='SST49LF004 4Mbit';
        Chip.T:='S';
        Chip.Size:=_4M;
       end;
 $BF5A:begin
        Chip.N:='SST49LF008A 8Mbit';
        Chip.T:='S';
        Chip.Size:=_8M;
       end;
// PMC
 $9D6D:begin
        Chip.N:='PM49FL002T 2Mbit';
        Chip.T:='S';
        Chip.Size:=_2M;
       end;
 $9D6E:begin
        Chip.N:='PM49FL004T 4Mbit';
        Chip.T:='S';
        Chip.Size:=_4M;
       end;
 $9D6A:begin
        Chip.N:='PM49FL008T 8Mbit';
        Chip.T:='S';
        Chip.Size:=_8M;
       end;
 end;
end;  //  3, 4  (SST  PMC)

if Chip.N='' then
begin
  s:=' : '+InttoHex(InputB[2],2)+
      ' '+InttoHex(InputB[3],2)+
      ' '+InttoHex(InputB[4],2)+
      ' '+InttoHex(InputB[5],2)+
      '.';
  form1.memo1.lines.add(s);
end
else
begin
form1.memo1.lines.add('    : '+Chip.N+'.');
result:=true;
end;
end;

indexb:=0;
form1.Com.FlushBuffers(TRUE,FAlse); //   
form1.memo1.lines.add('---   .');
form1.memo1.lines.add('');
end;
//------------------------------------------
procedure TForm1.IdentClick(Sender: TObject);
begin
if ButtonPressed then exit else ButtonPressed:=true;
if not PortHold then
begin
 MessageDlg('  !', mtError, [mbYes], 0);
 ButtonPressed:=false;
 exit;
end;
ExecIdent;
PortUnHold;
ButtonPressed:=false;
end;
//--------------------------------------------------
Function ReadOneBlock(SA:dword; SB:dword; VccOff:boolean):integer;
 Var EndRead:boolean;
     v :dword;
     TimeWaitData:dword;
begin

 ReadOneBlock:=-1;
//  
 SendBuffer[1]:=SA and $FF;               // A[7..0]
 SendBuffer[2]:=(SA shr  8) and $FF;      // A[15..8]
 SendBuffer[3]:=(SA shr 16) and $FF;      // A[23..16]

 SendBuffer[4]:=SB and $FF;;       //  ,  
 SendBuffer[5]:=(SB shr 8) and $FF;       //  

 if VccOFF then SendBuffer[7]:=_Last
  else SendBuffer[7]:=0;

//  0000  65536  
if not ExecCommand(_ReadBlock) then exit;

EndRead:=false;

while not EndRead do
begin
 v:=indexb;
 TimeWaitData:=GetTickCount+TimeOutData;

 While (TimeWaitData>GetTickCount)and(indexb<SB+8)
  do Application.ProcessMessages;   // 

 if v=indexb then EndRead:=true;     //   
 if indexb=SB+8 then EndRead:=true;  //   
end; // while not EndRead do

result:=IndexB; //    +8 (    )
end;
//--------------------------------------------------
procedure TForm1.READbuttonClick(Sender: TObject);
var i,BlockCounter:dword;
    TimeStart, TimeEnd:dword;
    Clear:boolean;
    NameFileToSave: string;
    ReadedBytes:longint;
begin
if ButtonPressed then exit else ButtonPressed:=true;

if not PortHold then
begin
 MessageDlg('  !', mtError, [mbYes], 0);
 ButtonPressed:=false;
 exit;
end;

if not ExecIdent then
begin
 ButtonPressed:=false;
 PortUnHold;
 exit;
end;

if Form1.SaveDialog1.execute then
 NameFileToSave:= Form1.SaveDialog1.FileName
 else
 begin
  Form1.Memo1.Lines.add('     !');
  Form1.Memo1.Lines.add('');
  PortUnHold;
  ButtonPressed:=false;
  Exit;
 end;

 if FindFile(NameFileToSave)>=0 then
 begin
  Form1.Memo1.Lines.add('    : "' +NameFileToSave+'"!');
  Form1.Memo1.Lines.add('    .');
  Form1.Memo1.Lines.add('');
  PortUnHold;
  ButtonPressed:=false;
  exit;
 end;

clear:=true;
form1.memo1.Lines.Add('    Status Bar...');
TimeStart:=GetTickCount;

for BlockCounter:=0 to (Chip.Size div BS)-1 do
begin

StatusBar1.SimpleText:=': '+ IntToStr((Chip.Size div BS)-BlockCounter)+' ().';

ReadedBytes:=0;

while ReadedBytes<>BS+8 do
begin
if BlockCounter<>(Chip.Size div BS)-1 then
  ReadedBytes:=ReadOneBlock(BlockCounter*BS,BS,false)        //      
  else ReadedBytes:=ReadOneBlock(BlockCounter*BS,BS,true);
if ReadedBytes<>BS+8 then
  memo1.Lines.Add('  ,  .')
end;

if indexb >8 then
begin
if BlockCounter=0 then
begin
 AssignFile(Fout,NameFileToSave);
 Rewrite(Fout);
end;

for i:=8 to indexb-1 do
 begin
  if Inputb[i]<>$0FF then Clear:=false;
  write(Fout, Inputb[i]);
 end;
IndexB:=0;
Com.FlushBuffers(TRUE,TRUE); //  
end;
end;
PortUnHold;
CloseFile(Fout);
if clear then
memo1.Lines.Add(': '+IntTostr(BlockCounter*BS)+' (/).  .')
else memo1.Lines.Add(': '+IntTostr(BlockCounter*BS)+' (/).');
TimeEnd:=GetTickCount;
form1.memo1.Lines.Add('    '+IntTostr((TimeEnd-TimeStart) div 1000)+'.');
form1.memo1.Lines.Add('   : "'+NameFileToSave+ '".');
form1.memo1.Lines.Add('+++   .');
memo1.Lines.Add('');
StatusBar1.SimpleText:='';
ButtonPressed:=false;
end;
//------------------------------------------
Function EraseIntel:boolean;
var i:dword;
begin
result:=false;

SendBuffer[1]:=0;       // A[7..0]
SendBuffer[2]:=0;       // A[15..8]
SendBuffer[3]:=$F8;     // A[19..16]
SendBuffer[4]:=ord('I');       //   Intel

TimeOutCommand:=15000;
result:=true;
for i:=0 to (Chip.Size shr 16)-1 do         //  64K   
begin
SendBuffer[3]:=$F8+i;     // A[23..16]
 if i=0 then SendBuffer[5]:=_First  //  
 else SendBuffer[5]:=0;

 if i=(Chip.Size shr 16)-1 then SendBuffer[5]:=_Last;    //  

if ExecCommand(_EraseBlock) then
begin
if (InputB[2] and $FE) = $80 then
  form1.memo1.Lines.Add('Erase Block '+inttostr(i)+'  .')
else begin
 result:=false;
 form1.memo1.Lines.Add('Erase Block '+inttostr(i)+
 '  c !   FHM='+IntToHex(InputB[2],2)+'.')
 end;
end;
end;//for i:=0 to
end;
//------------------------------------------
function EraseSST:boolean;
begin
result:=false;
SendBuffer[1]:=0;       // A[7..0]
SendBuffer[2]:=0;       // A[15..8]
SendBuffer[3]:=$0FC;    // A[15..8]   2M
SendBuffer[4]:=ord('S');       //   SST
TimeOutCommand:=15000;

SendBuffer[5]:=_FullErase;  //  ( )

if ExecCommand(_EraseBlock) then
begin
if (InputB[0]=_OK)and(InputB[1]=_EraseBlock)and(InputB[2]=$80) then
 begin
  form1.memo1.Lines.Add('Erase CHIP  .');
  result:=true;
 end
else form1.memo1.Lines.Add('Erase CHIP  c !   ='
       +IntToHex(InputB[0],2)+' '
       +IntToHex(InputB[1],2)+' '
       +IntToHex(InputB[3],2)+'.')
end;

end;
//------------------------------------------
Function EraseChip:boolean;
begin
result:=false;
form1.memo1.Lines.Add('+++   .');

if not ExecIdent then
begin
 form1.memo1.Lines.Add('     !');
 form1.memo1.Lines.Add('---   .');
 exit;
end;

case Chip.T of
 'I' :result:=EraseIntel;
 'S' :result:=EraseSST;
 else
  form1.memo1.Lines.Add('     !');
end;

form1.Com.FlushBuffers(TRUE,TRUE); //   
indexb:=0;
form1.memo1.Lines.Add('---Erase .');
form1.memo1.Lines.Add('');
end;
//------------------------------------------
procedure TForm1.EraseClick(Sender: TObject);
begin
if ButtonPressed then exit else ButtonPressed:=true;
if not PortHold then
begin
 MessageDlg('  !', mtError, [mbYes], 0);
 ButtonPressed:=false;
 exit;
end;
EraseChip;
PortUnHold;
ButtonPressed:=false;
end;
//----------------------------------------
procedure TForm1.WriteBlockClick(Sender: TObject);
var BlockCounter,i:dword;
    p:pointer;
    r:dword;
    Acounter:dword;
    LengthFileToWrite:dword;
    b:boolean;
    NameFileToWrite:string;
    TimeStart,TimeEnd:longint;
    clear:boolean;
begin
if ButtonPressed then exit else buttonPressed:=true;

if not PortHold then
begin
 MessageDlg('  !', mtError, [mbYes], 0);
 ButtonPressed:=false;
 exit;
end;

if not ExecIdent then
begin
 buttonPressed:=false;
 PortUnHold;
 exit;
end;


LengthFileToWrite:=0;
b:=false;
while not b do
begin
if Form1.OpenDialog1.execute then
 begin
   NameFileToWrite:= Form1.OpenDialog1.FileName;
   LengthFileToWrite:=FindFile(NameFileToWrite);
  if LengthFileToWrite>Chip.Size then
     begin
      Form1.Memo1.Lines.add('      !');
      if MessageDlg('    !', mtError, [mbOK, mbCancel],0)=mrCancel
       then b:=true;
     end;

  if LengthFileToWrite<Chip.Size then
     begin
      if MessageDlg('    !', mtError, [mbOK, mbCancel], 0)=mrCancel
       then b:=true;
      Form1.Memo1.Lines.add('      !');
     end;

if LengthFileToWrite=Chip.Size then b:=true;
end; // if Opendialog.Execute

if (LengthFileToWrite<>0)and(not b) then   //     
 LengthFileToWrite:=0                      //   
 else b:=true;     //  

end; // While

if LengthFileToWrite<>Chip.Size  then//   
begin
 Form1.Memo1.Lines.add('     !');
 StatusBar1.SimpleText:='.';
 PortUnHold;
 ButtonPressed:=false;
 Exit;
end;

if not form1.CheckBox1.Checked then
 if not EraseChip then
  begin
   Form1.Memo1.Lines.add('+++   !');
   buttonPressed:=false;
   PortUnHold;
   exit;
  end;

AssignFile(Fin, NameFileToWrite);
Reset(fin);
//begin
// memo1.Lines.Add('     : "'+ NameFileToWrite+'"!')
// ButtonPressed:=false;
// exit;
//end;

SendBuffer[4]:=ord(Chip.T);     //     :-)

memo1.Lines.Add('     : "'+ NameFileToWrite + '"   Status bar...');
TimeStart:=GetTickCount;
for BlockCounter:=0 to (Chip.Size div MinBlock)-1 do
begin  //     MinBlock
StatusBar1.SimpleText:=': '+ IntToStr((Chip.Size div MinBlock)-BlockCounter)+' (/).';
 //   
 delay(100); //     
 Acounter:=BlockCounter*MinBlock;
 SendBuffer[1]:=Acounter and $FF;          // A[7..0]
 SendBuffer[2]:=(Acounter shr 8) and $FF;  // A[15..8]
 SendBuffer[3]:=(Acounter shr 16) and $FF; // A[23..16]
 SendBuffer[5]:=(MinBlock div 128) and $FF;  //    
 SendBuffer[6]:=((MinBlock div 128) shr 8) and $FF;  //   

 if BlockCounter=0 then SendBuffer[7]:=_First //  ,  
  else SendBuffer[7]:=0;

 if BlockCounter=(Chip.Size div MinBlock)-1 then
  SendBuffer[7]:=_last;

for i:=0 to (MinBlock shr 7)-1 do
 begin  //  MinBlock  128 ,      

indexb:=0;
TimeOutCommand:=10000;
if i = 0 then
begin
 if not ExecCommand(_WriteBlock) then memo1.Lines.Add('   "Write Block"  .')
end
 else if not GetAnswer then memo1.Lines.Add('  "Get Answer" Error!');

 Read(Fin, DataBuffer);
{
 clear:=true;   //        FF
 r:=128;        //   128 
 while clear and (r>0) do
 begin
 if DataBuffer[i]<>$FF then clear:=false;
 dec(R)
 end;

 if not clear then      //  
begin
}

 p:= @DataBuffer[0];
 form1.Com.FlushBuffers(TRUE,TRUE); //  
 r:=form1.com.SendData(p,128);
if r<>128 then memo1.Lines.Add('   :'+IntToStr(r)+'(a/)!');

end;  // for i:=0 to (MinBlock shr 7)
end; // BlockCounter

TimeEnd:=GetTickCount;
form1.memo1.Lines.Add('    '+IntTostr((TimeEnd-TimeStart) div 1000)+'.');
form1.memo1.Lines.Add('+++   .');
form1.memo1.Lines.Add('');
StatusBar1.SimpleText:='.';
PortUnHold;
ButtonPressed:=false;
end;
//----------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
var p:pointer;
    TheTime:dword;
begin
SetLength(InputB, 100000);
form1.memo1.lines.add('  .');
SendBuffer[0]:=_empty;
IndexB:=0; //    
inputB[0]:=$0AA;
inputB[1]:=$0FF;
p:= @SendBuffer;
form1.Com.FlushBuffers(TRUE,TRUE); //  
//form1.com.SendData(p,8);
//TheTime:=GetTickCount+TimeOutCommand;

//While (IndexB<8)and (TheTime>GetTickCount)
// do Application.ProcessMessages;

//if (indexb<>8)and(inputB[0]<>0)and(inputB[1]<>_empty) then
//begin
//form1.memo1.lines.add('');
//MessageDlg('  !', mtError, [mbOk], 0);
//Halt;
//end;

//form1.memo1.lines.add(' .');
//IndexB:=0;
//form1.memo1.lines.add('');
end;

end.
